
; Listing23c2.s		BPL-Pointer Mid-Screen nderung
;					nderung von 2 Bitplanepointern um ein anderes playfiled anzuzeigen	
;					Variante mit Speicher auf $xx0000 ausgerichtet anfordern		

; asmone Allocate:c/100kb

; AmigaOS constants
EXECBASE	equ	4

; exec LVOs
Forbid		equ	-132
Permit		equ	-138
AllocMem	equ	-198
FreeMem		equ	-210
AvailMem	equ	-216
AllocAbs	equ	-204

DISPLAY_DX=320
DISPLAY_DY=256
DISPLAY_DEPTH=2
size = 2*(DISPLAY_DEPTH*DISPLAY_DY*(DISPLAY_DX>>3))


	SECTION CiriCop,CODE

Anfang:
	move.l	4.w,a6				; Execbase
	jsr	-$78(a6)				; Disable
	lea	GfxName(PC),a1			; Libname
	jsr	-$198(a6)				; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop		; speichern die alte COP
	
	; Pointen auf das "leere" PIC - wird hier nicht bentigt
	; Pointen auf den Sprite	  - wird hier nicht bentigt

	bsr memory					; Speicher anfordern
	bsr fill_playfield1
	bsr fill_playfield2	
	bsr init_cop				; Copperliste erstellen

	move.l	#COPPERLIST,$dff080	; unsere COP
	;move.w	d0,$dff088			; START COP
	move.w	#0,$dff1fc			; NO AGA!
	move.w	#$c00,$dff106

mouse:	
	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse				; wenn nicht, zurck zu mouse:

	; Speicher freigeben
	movea.l playfield1,a1		; Anfangsadresse
	move.l #size,d0				; fr beide playfields freigeben
	movea.l $4,a6
	jsr -210(a6)
	
	move.l	OldCop(PC),$dff080 	; COP1LC - "Zeiger" auf die Orginal-COP
	move.w	d0,$dff088			; COPJMP1 - und starten sie

	move.l	4.w,a6
	jsr	-$7e(a6)				; Enable - stellt Multitasking wieder her
	move.l	GfxBase(PC),a1		; Basis der Library, die es zu schlieen gilt
								; (Libraries werden geffnet UND geschlossen!)
	jsr	-$19e(a6)				; Closelibrary - schliet die Graphics lib
	rts

GfxName:
	dc.b	"graphics.library",0,0	

GfxBase:	     ; Hier hinein kommt die Basisadresse der graphics.library,
	dc.l	0    ; ab hier werden die Offsets gemacht

OldCop:			; Hier hinein kommt die Adresse der Orginal-Copperlist
	dc.l	0	; des Betriebssystemes

;********** Daten **********

;playfield1:		dc.l 0		; nur zum Vergleich
playfield1:	dc.l 0		; Anfangsadresse auf $xx0000 ausgerichtet
playfield2:	dc.l 0		; 

;------------------------------------------------------------
memory:
; --- part 1 ---
; ein Speichersegment, das auf $xx0000 ausgerichtet ist, kann man nur selber
; anfordern. z.B.:
; zuerst die gewnschte Chip-RAM Gre + 65535 Bytes anfordern (um Raum fr
; das Alignment zu haben)

	move.l #size+$ffff,d0						; move.l  #size+$ffff,d0
	move.l #$10002,d1							; move.l  #MEMF_CHIP,d1
	movea.l $4,a6								; Execbase			
	jsr -198(a6)								; jsr     AllocMem(a6)
	; move.l d0,playfield1						; nur zum Vergleich
	; beq     not_enough_chip_memory			

; --- part 2 ---
; dann verbietet man Task-Switching um sicher zu gehen da kein anderer Task
; dazwischenfunkt
	move.l d0,d2								; Kopie		
	jsr -132(a6)								; jsr     Forbid(a6)
	move.l  d2,a1						
   
; --- part 3 ---  
; danach gibt man den Speicher wieder frei und belegt ihn sofort wieder mit 
; AllocAbs() an einer durch $10000 teilbaren Adresse. Die Adresse findest man
; dann in playfield1 (bzw. playfield2).

	move.l #size+$ffff,d0						; move.l  #size+$ffff,d0
    jsr -210(a6)								; jsr     FreeMem(a6)
   
    add.l   #$ffff,d2
    and.l   #$ffff0000,d2						; clr.w d2
    move.l  d2,playfield1						; Adresse des angeforderten Speichers
	move.l  d2,playfield2
	add.l	#size/2,playfield2					; playfield 2 liegt direkt dahinter
    move.l  d2,a1
    move.l  #size,d0
    jsr     -204(a6)							; jsr     AllocAbs(a6)
    jsr     -138(a6)							; jsr     Permit(a6)

	rts
;------------------------------------------------------------
fill_playfield1:

; playfield 1 - bitebene 1----------------
	movea.l playfield1,a0
	move.l #-1,d0			; die Bitplane fllen	
	move.w #2560-1,d1		; 320/8=40 Bytes 10.l*256 Zeilen
fb1_1:
	move.l d0,(a0)+
	dbf d1,fb1_1

; playfield 1 - bitebene 2----------------
	movea.l playfield1,a0
	lea 40*256(a0),a0
	move.l #$10001000,d0	; senkrechte Linien	
	move.w #2560-1,d1		; 320/8=40 Bytes 10.l
fb1_2:
	move.l d0,(a0)+
	dbf d1,fb1_2

	rts
;------------------------------------------------------------

fill_playfield2:
; playfield 2 - bitebene 2----------------
	movea.l playfield2,a0
	lea 40*256(a0),a0
	move.l #$ffffffff,d0
	moveq #16-1,d2	
fb2_2b:	
	moveq #10-1,d1		; 320/8=40 Bytes 10.l
fb2_2:
	move.l d0,(a0)+
	dbf d1,fb2_2
	lea 15*40(a0),a0
	dbf d2,fb2_2b

	rts	
;------------------------------------------------------------

init_cop:
	moveq #0,d2
	moveq #0,d4

	lea copper_mid_screen,a0
	move.l	#$2c03fffe,d0			; wait am Anfang	
	move.l	#$2c83fffe,d3			; wait mid-screen
	move.b  #$2c,d7					; Startzeile

	moveq #0,d1
	move.w #256-1,d1				; Anzahl der Zeilen
all_lines:	
	move.l playfield2,d5			; Basisadresse playfield1
	move.l playfield1,d6			; Basisadresse playfield2
	add.l d2,d5						; + Anzahl Zeilen 
	add.l d4,d6						; + Anzahl Zeilen 
	move.l d0,(a0)+					; 1. wait setzen
	;1. Bitebene
	move.w  #$00e2,(a0)+			; BPL1PTL - playfield 1
    move.w  d5,(a0)+				; low-Teil
	swap d5							; hi-low tauschen
	move.w  #$00e0,(a0)+			; BPL1PTH - playfield 1
    move.w  d5,(a0)+				; hi-Teil
	swap d5							; Adresse in richtige Reihenfolge bringen
	;2. Bitebene
	add.l #40*256,d5				; an den Anfang von Bitebene 2 von playfield2
	move.w  #$00e6,(a0)+			; BPL2PTL - playfield 1
    move.w  d5,(a0)+				; low-Teil
	swap d5							; hi-low tauschen
	move.w  #$00e4,(a0)+			; BPL2PTH - playfield 1
    move.w  d5,(a0)+				; hi-Teil
	swap d5							; Adresse in richtige Reihenfolge bringen
	add.l #40,d2					; 40 Bytes hinzufgen - eine Zeile
	; in der Mitte des Screens auf das zweite playfield pointen
;----------
	move.l d3,(a0)+					; wait mid-screen setzen
	
	;2. Bitebene	
	add.l #40*256,d6				; an den Anfang von Bitebene 2 von playfield2
	move.w  #$00e6,(a0)+			; BPL2PTL - playfield 2
    move.w  d6,(a0)+				; low-Teil
	;swap d6						; hi-low tauschen
	;move.w  #$00e4,(a0)+			; BPL2PTH - playfield 2
    ;move.w  d6,(a0)+				; hi-Teil
	;swap d6						; Adresse in richtige Reihenfolge bringen
	;1. Bitebene
	sub.l #40*256,d6
	move.w  #$00e2,(a0)+			; BPL1PTL - playfield 2
	move.w  d6,(a0)+				; low-Teil
	;swap d6						; hi-low tauschen
	;move.w  #$00e0,(a0)+			; BPL1PTH - playfield 2
    ;move.w  d6,(a0)+				; hi-Teil
    ;swap d6						; Adresse in richtige Reihenfolge bringen	
	
	cmp.b  #$ff,d7					; Zeile $ff erreicht?
	bne no_ff
	move.l #$ffdffffe,(a0)+			; wenn ja, wait am Ende einfgen
no_ff:
	add.l #40,d4					; 40 Bytes hinzufgen - eine Zeile	
	add.l #$01000000,d0				; nchste Zeile wait am Anfang
	add.l #$01000000,d3				; nchste Zeile wait Mitte
	add.b #1,d7
	dbf d1,all_lines

	; fr den Rest des Screens Bitplanepointer auf playfield 1 setzen
	
	move.l playfield1,d5			; Basisadresse playfield1
	add.l d2,d5						; + Anzahl Zeilen 
	move.l d0,(a0)+					; wait am Anfang setzen
	;1. Bitebene
	move.w  #$00e2,(a0)+			; BPL1PTL - playfield 1
    move.w  d5,(a0)+				; low-Teil
	swap d5							; hi-low tauschen
	move.w  #$00e0,(a0)+			; BPL1PTH - playfield 1
    move.w  d5,(a0)+				; hi-Teil
	swap d5							; Adresse in richtige Reihenfolge bringen
	;2. Bitebene
	add.l #40*256,d5				; an den Anfang von Bitebene 2 von playfield2
	move.w  #$00e6,(a0)+			; BPL2PTL - playfield 1
    move.w  d5,(a0)+				; low-Teil
	swap d5							; hi-low tauschen
	move.w  #$00e4,(a0)+			; BPL2PTH - playfield 1
    move.w  d5,(a0)+				; hi-Teil
	swap d5							; Adresse in richtige Reihenfolge bringen
	
	move.l  #$2c07fffe,(a0)+		; Warte auf Zeile $60
	move.l  #$0142000,(a0)+			; SPR0CTL - "deaktiviert" den Sprite	
	rts
		
	
	SECTION GRAPHIC,DATA_C

COPPERLIST:

	; Die Sprites lassen wir auf NULL zeigen, also pointen, um sie zu 
	; eliminieren ansonsten geistern sie umher uns stren uns nur!!!
SpritePointers:
	dc.w	$120,$0000,$122,$0000,$124,$0000,$126,$0000,$128,$0000
	dc.w	$12a,$0000,$12c,$0000,$12e,$0000,$130,$0000,$132,$0000
	dc.w	$134,$0000,$136,$0000,$138,$0000,$13a,$0000,$13c,$0000
	dc.w	$13e,$0000
		
	dc.w	$8e,$2c81	; DiwStrt	Register mit Standartwerten
	dc.w	$90,$2cc1	; DiwStop	
	dc.w	$92,$0038	; DdfStart
	dc.w	$94,$00d0	; DdfStop
	dc.w	$102,0		; BplCon1
	dc.w	$104,$22	; BplCon2
	dc.w	$108,0		; Bpl1Mod
	dc.w	$10a,0		; Bpl2Mod

	; das BPLCON0 ($dff100) fr einen Bildschirm mit 1 Bitplane: (2 Farben)
				; 5432109876543210
	;dc.w	$100,%0001001000000000	; bit 12 an!!		  (1 = %001)	1 Bitplanes: (2 Farben)
	dc.w	$100,%0010001000000000	; bit 13 an!!		  (2 = %010)	2 Bitplanes: (4 Farben)
	;dc.w	$100,%0011001000000000	; bits 13 und 12 an!! (3 = %011)	3 Bitplanes: (8 Farben)
	;dc.w	$100,%0100001000000000	; bit 14 an!!		  (4 = %100)	4 Bitplanes: (16 Farben)
	;dc.w	$100,%0101001000000000	; bits 14 und 12 an!! (5 = %101)	5 Bitplanes: (32 Farben)
	;dc.w	$100,%0110001000000000	; bits 14 und 13 an!! (6 = %110)	6 Bitplanes: (64 Farben)


;	Wir lassen die Bitplanes direkt anpointen, indem wir die Register
;	$dff0e0 und folgende hier in der Copperlist einfgen. Die
;	Adressen der Bitplanes werden dann von der Routine POINTBP
;	automatisch eingetragen
	
BPLPOINTERS:
	dc.w $e0,$0000,$e2,$0000	; erste	Bitplane - BPL0PT
	dc.w $e4,$0000,$e6,$0000	; zweite Bitplane - BPL1PT
	;dc.w $e8,$0000,$ea,$0000	; dritte Bitplane - BPL2PT
	;dc.w $ec,$0000,$ee,$0000	; vierte Bitplane - BPL3PT
	;dc.w $f0,$0000,$f2,$0000	; fnfte Bitplane - BPL4PT
	;dc.w $f4,$0000,$f6,$0000	; sechste Bitplane - BPL5PT


; Die 8 Farben des Bildes werden hier definiert:
	dc.w	$0180,$000	; color0
	dc.w	$0182,$fff	; color1
	dc.w	$0184,$f00	; color2
	dc.w	$0186,$00f	; color3
	dc.w	$0188,$0f0	; color4
	dc.w	$018a,$ff0	; color5
	dc.w	$018c,$0f0	; color6
	dc.w	$018e,$0ff	; color7

; die weiteren Farben
	dc.w	$0190,$0ff	; color08
	dc.w	$0192,$444	; color09
	dc.w	$0194,$444	; color10
	dc.w	$0196,$444	; color11
	dc.w	$0198,$444	; color12
	dc.w	$019a,$444	; color13
	dc.w	$019c,$444	; color14
	dc.w	$019e,$444	; color15
	dc.w	$01a0,$444	; color16
	dc.w	$01a2,$0FF	; color17
	dc.w	$01a4,$F00	; color18
	dc.w	$01a6,$F00	; color19
	;dc.w	$01a8,$444	; color20
	;dc.w	$01aa,$444	; color21
	;dc.w	$01ac,$444	; color22
	;dc.w	$01ae,$444	; color23
	;dc.w	$01b0,$444	; color24
	;dc.w	$01b2,$444	; color25
	;dc.w	$01b4,$444	; color26
	;dc.w	$01b6,$444	; color27
	;dc.w	$01b8,$444	; color28
	;dc.w	$01ba,$444	; color29
	;dc.w	$01bc,$444	; color30
	;dc.w	$01be,$444	; color31

	dc.w	$2b07,$fffe		; Warte auf Zeile $2b um rechtzeitig das Sprite vorzubereiten
	dc.w	$140,$0090		; SPR0POS - Horizontale Position
	dc.w	$142,$0000		; SPR0CTL
	dc.w	$146,$0000		; SPR0DATB
	dc.w	$144,$e000		; SPR0DATA - aktiviert Sprite
	
copper_mid_screen:
	; 256*(8+24)+4=8200	
	; 2 x wait			2*4
	; 6 x copper-move	6*4
	; + extra wait		4
		
	blk.l	2060,$fffffffe	; ca. blk.b	8200/2/2,0
		
	dc.w	$ffff,$fffe		; Ende der copperlist
	dc.w	$9876,$5432		; Endetest
			
	end
	
Erklrung:

Wie eben nur das wir in diesem Beispiel zunchst fr zwei playfields mit 
jeweils 2 Bitebenen leeren  Speicher anfordern. Dies Anfangsadresse dieses
Speicherbereiches richten wir dabei auf 64k-Grenzen ein. Dies hat fr uns
den Vorteil spter in der Copperliste nur noch mit den Low-Pointern zu
arbeiten, weil der Highpointer-Teil unverndert bleibt.

