
; Listing23d.s		Routine Interlaced Mode Management (640x512)
;			der das Bit 15 (LOF) von VPOSR ($dff004) liest.
;			Wechsel der Halbbilder durch Copperliste	

	SECTION	Interlace,CODE

;	Include	"DaWorkBench.s"		; entferne das; vor dem Speichern mit "WO"

*****************************************************************************
	include "/Sources/startup2.s"	; speichern copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001110000000	; nur copper und bitplane DMA

WaitDisk	EQU	30

scr_bytes	= 80				; Anzahl der Bytes fr jede horizontale Zeile.
								; Daraus berechnen wir die Bildschirmbreite,
								; Multiplizieren von Bytes mit 8: normaler Bildschirm 320/8 = 40
								; z.B. fr einen 336 Pixel breiten Bildschirm 336/8 = 42
								; Beispielbreiten:
								; 264 pixel = 33 / 272 pixel = 34 / 280 pixel = 35
								; 360 pixel = 45 / 368 pixel = 46 / 376 pixel = 47
								; ... 640 pixel = 80 / 648 pixel = 81 ...

scr_h		= 256				; Bildschirmhhe in Zeilen
scr_x		= $81				; Startbildschirm, XX-Position (normal $xx81) (129)
scr_y		= $2c				; Startbildschirm, YY-Position (normal $2cxx) (44)
scr_res		= 2					; 2 = HighRes (640*xxx) / 1 = LowRes (320*xxx)
scr_lace	= 1					; 0 = non interlace (xxx*256) / 1 = interlace (xxx*512)
ham			= 0					; 0 = non ham / 1 = ham
scr_bpl		= 1					; Anzahl Bitplanes

; Parameter automatisch berechnet

scr_w		= scr_bytes*8		; Bildschirmbreite
scr_size	= scr_bytes*scr_h	; Gre in Bytes des Bildschirms
BPLC0	= ((scr_res&2)<<14)+(scr_bpl<<12)+$200+(scr_lace<<2)+(ham<<11)
DIWS	= (scr_y<<8)+scr_x
DIWSt	= ((scr_y+scr_h/(scr_lace+1))&255)<<8+(scr_x+scr_w/scr_res)&255
DDFS	= (scr_x-(16/scr_res+1))/2
DDFSt	= DDFS+(8/scr_res)*(scr_bytes/2-scr_res)


START:
	MOVE.L	#BITPLANE,d0		; wohin pointen
	LEA	BPLPOINTERS1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)	

	MOVE.L	#BITPLANE+80,d0		; wohin pointen
	LEA	BPLPOINTERS2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	
	MOVE.L	#Cop_lace2,d0		; wohin pointen
	LEA	COP_Pointer1,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.L	#Cop_lace1,d0		; wohin pointen
	LEA	COP_Pointer2,A1			; COP-Pointer
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	MOVE.W	#DMASET,$96(a5)		; DMACON - aktivieren bitplane, copper
	move.l	#Copperlist,$dff084 ; COPL2
	move.w	#0,$1fc(a5)			; AGA deaktivieren
	move.w	#$c00,$106(a5)		; AGA deaktivieren
	move.w	#$11,$10c(a5)		; AGA deaktivieren

	bsr LACEINT					; LOF-Bit testen und Copperpointer eintragen

mouse:
	MOVE.L	#$1ff00,d1			; Bit zur Auswahl durch UND
	MOVE.L	#$01000,d2			; warte auf Zeile $010
Waity1:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	BNE.S	Waity1
Waity2:
	MOVE.L	4(A5),D0			; VPOSR und VHPOSR - $dff004/$dff006
	ANDI.L	D1,D0				; whlen Sie nur die Bits der vertikalen Pos.
	CMPI.L	D2,D0				; warte auf Zeile $010
	Beq.S	Waity2
	
	bsr.w	PrintCarattere		; Drucken Sie jeweils ein Zeichen

	btst	#6,$bfe001			; Maus gedrckt?
	bne.s	mouse

	rts

******************************************************************************
; INTERLACE ROUTINE - Test Bit LOF (Long Frame) um zu wissen, ob Sie
; gerade oder ungerade Zeilen anzeigen und entsprechend wechseln mssen.
******************************************************************************
LACEINT:
	btst.b	#15-8,4(A5)			; VPOSR LOF bit?
	Beq.s	Faidispari			; wenn ja, zeigen Sie auf ungerade Zeilen
	
								; Starten der Ansicht von den geraden Zeilen!
								; zweitens: gerade Zeilen werden angezeigt!
	move.l	#Cop_lace1,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts

FaiDispari:
	move.l	#Cop_lace2,$dff080	; unsere COP
	move.w	d0,$dff088			; START COP
	rts


*****************************************************************************
;			Druck Routine
*****************************************************************************

PRINTcarattere:
	MOVE.L	PuntaTESTO(PC),A0	; Adresse des zu druckenden Textes a0
	MOVEQ	#0,D2				; d2 lschen
	MOVE.B	(A0)+,D2			; Nchstes Zeichen in d2
	CMP.B	#$ff,d2				; Ende des Textsignals? ($FF)
	beq.s	FineTesto			; Wenn ja, beenden Sie ohne zu drucken
	TST.B	d2					; Zeilenende-Signal? ($00)
	bne.s	NonFineRiga			; Wenn nicht, nicht aufhren

	ADD.L	#scr_bytes*7,PuntaBITPLANE	; wir gehen zum Anfang
	ADDQ.L	#1,PuntaTesto		; erste Zeichenzeile danach
								; (berspringe die NULL)
	move.b	(a0)+,d2			; erstes Zeichen der Zeile nach
								; (berspringe die NULL)

NonFineRiga:
	SUB.B	#$20,D2				; ZHLE 32 VOM ASCII-WERT DES BUCHSTABEN WEG
								; SOMIT VERWANDELN WIR Z.B. DAS LEERZEICHEN
								; (Das $20 entspricht), IN $00, DAS
								; AUSRUFUNGSZEICHEN ($21) IN $01...
	LSL.W	#3,D2				; MULTIPLIZIERE DIE ERHALTENE ZAHL MIT 8,
								; da die Charakter ja 8 Pixel hoch sind
	MOVE.L	D2,A2
	ADD.L	#FONT,A2			; FINDE DEN GEWNSCHTEN BUCHSTABEN IM FONT...

	MOVE.L	PuntaBITPLANE(PC),A3 ; Adresse Ziel-Bitplane in a3

								; DRUCKE DEN BUCHSTABEN ZEILE FR ZEILE
	MOVE.B	(A2)+,(A3)			; Drucke Zeile 1 des Zeichens
	MOVE.B	(A2)+,scr_bytes(A3)		; Drucke Zeile  2  " "
	MOVE.B	(A2)+,scr_bytes*2(A3)	; Drucke Zeile  3  " "
	MOVE.B	(A2)+,scr_bytes*3(A3)	; Drucke Zeile  4  " "
	MOVE.B	(A2)+,scr_bytes*4(A3)	; Drucke Zeile  5  " "
	MOVE.B	(A2)+,scr_bytes*5(A3)	; Drucke Zeile  6  " "
	MOVE.B	(A2)+,scr_bytes*6(A3)	; Drucke Zeile  7  " "
	MOVE.B	(A2)+,scr_bytes*7(A3)	; Drucke Zeile  8  " "

	ADDQ.L	#1,PuntaBitplane	; wir rcken 8 Bits vor (NCHSTES ZEICHEN)
	ADDQ.L	#1,PuntaTesto		; nchstes zu druckendes Zeichen

FineTesto:
	RTS

PuntaTesto:
	dc.l	TESTO

PuntaBitplane:
	dc.l	BITPLANE

;	$00 fr "Zeilenende" - $FF fr "Textende"

		; Anzahl der Zeichen pro Zeile: 40
TESTO:	     ;		  1111111111222222222233333333334
         ;   1234567890123456789012345678901234567890
	dc.b	' Che scritte piccole! Non si leggono nem'   ; 1		; Was fuer eine kleine Schrift! Man kann sie 
	dc.b	'meno... ma sono in 640x512!             ',0 ; 1b		; fast nicht lesen... aber sie ist in 640x512!
;
	dc.b	'Provate a premere il tasto destro e potr'   ; 2		; Wenn Sie die rechte Taste druecken koennen
	dc.b	'ete verificare cosa vedono i coder che  ',0 ; 2b		; Sie berprfen, was die Programmierer sehen
;
	dc.b	"non sanno come funziona l'interlace, hah"   ; 3		; Sie wissen nicht, wie Interlace funktioniert, hah	
	dc.b	"aha! In fondo e' semplice, no?          ",0 ; 3b		; Aha! Es ist schlielich einfach, oder?
;
	dc.b	'Programmate, fate qualche demo o qualche'   ; 4		; Programmieren, ein paar Demos machen oder so oder ein
	dc.b	" gioco, e' la cosa piu' creativa che si ",0 ; 4b		; Spiel, es ist das Kreativste, was man tun kann
;
	dc.b	'possa fare nel mondo contemporaneo.     '   ; 5		; in der heutigen Welt.
	dc.b	'                                        ',$FF ; 5b - Ende

	EVEN
	
;	Die FONT-Zeichen 8x8.

FONT:
	incbin	"/Sources/nice.fnt"

******************************************************************************

	SECTION	GRAPHIC,DATA_C
	
Cop_lace1:
BPLPOINTERS1:
	dc.w	$e0,0,$e2,0		; erste Bitplane
COP_Pointer1:
	dc.w 	$80,$0,$82,$0	; auf Cop_lace2 setzen 
	dc.w 	$8a,$0			; COPJMP2

Cop_lace2:
BPLPOINTERS2:
	dc.w	$e0,0,$e2,0		; erste Bitplane+80
COP_Pointer2:
	dc.w 	$80,$0,$82,$0	; auf Cop_lace1 setzen 

Copperlist:	
	dc.w	$8e,DIWS	; DiwStrt
	dc.w	$90,DIWSt	; DiwStop
	dc.w	$92,DDFS	; DdfStart
	dc.w	$94,DDFSt	; DdfStop

	dc.w	$102,0		; BplCon1
	dc.w	$104,0		; BplCon2
	dc.w	$108,80		; Bpl1Mod \ INTERLACE: modulo = Lnge Zeile!
	dc.w	$10a,80		; Bpl2Mod / um sie zu berspringen (die geraden)

				; 5432109876543210
;	dc.w	$100,%1001001000000100	; 1 bitplane, HIRES LACE 640x512
;								; Beachten Sie das Bit 2 Set fr LACE!!

	dc.w	$100,BPLC0			; BplCon0 -> lassen Sie es uns automatisch berechnen!
	
	dc.w	$180,$226			; color0 - Hintergrund
	dc.w	$182,$0b0			; color1 - plane 1 Position normal, und
								; der "klebende" Teil an der Spitze.

	dc.w	$ffff,$fffe			; Ende copperlist


******************************************************************************

	SECTION	MIOPLANE,BSS_C

BITPLANE:
	ds.b	scr_bytes*scr_h		; 80*512 eine bitplane Hires int. 640x512

	end

Erklrung:

Bei interlace muss entsprechend des Zustands des LOF-Bit's jedes zweite Halbbild
etwas tiefer beginnen, was bei einem 320 Pixel breiten Bild 40 Bytes entspricht.
Bei hires ist es das doppelte, also 80 Bytes.

Die bekannten Verfahren sind dabei gewhnlich:
1. Copperlisten verdoppeln und nur die Bitplanepointer sind in den Copperlisten
   unterschiedlich

2. In jedem Frame einen Test des LOF-Bit's durchfhren und je nach Ergebnis
die Bitplanepointer in der Copperliste mit oder ohne dem Abstand jedesmal
aktualisieren.

3. In diesem Beispiel wird eine andere Variante vorgeschlagen, die sehr schnell
und effektiv ist und zwar einzig durch die Copperliste selbst erfolgt.

Nach jedem vertikal Blank wird die Copperliste von dort gestartet auf die der
COP1LC aktuell zeigt. Und es gibt zwei Zieladressen fr den COP1LC. In beiden
Fllen steht als erste Anweisung die Bitplanepointer, einmal mit und einmal ohne
dem 80 Bytes Abstand. Wobei diese Bitplanepointer auch nur einmal whrend der
Initialisierung zur Laufzeit dort eingetragen werden.
Nach dem Start der Copperliste und der Aktualisierung der Bitplanepointer erfolgt
nun der "Rest" in der Copperliste, wobei nur in jedem zweiten Frame ein Teil der
Copperliste bersprungen werden muss, was durch den COPJMP2 erfolgt.

Init:
	LOF-Bit testen
	COPPT setzen
	Start on the fly mit cop_lace1 oder cop_lace2
	
2 Copperlisten anlegen

Cop_lace2:			Cop_lace1:
	BPLPTH+x			BPLPTH
	COP1=COP_lace1		COP1=COP_lace2
	|					COP2JMP to Copperlist
Copperlist:
	|
	Cop Wait, Moves
	|
	Cop_Ende		


Vergleiche Listing11l6.s dazu.





