
; Listing25c3.s		horizontales Spritemultiplexing mit wait und SPRxPOS
;                   ber die gesamte Bildschirmzeile mehrere Reihen
;					mit Copper-Move		("halbautomatischer Modus")

spritekanal = 0				; 0 - SPR0 , 1 - SPR1 .... , 7 - SPR7

	SECTION R'nR,CODE

Anfang:
	move.l	4.w,a6			; Execbase
	jsr	-$78(a6)			; Disable
	lea	GfxName(PC),a1		; Libname
	jsr	-$198(a6)			; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; wir speichern die alte COP

	; Pointen auf das "leere" Bild

	MOVE.L	#BITPLANE,d0	; Adresse der Bitplane
	LEA	BPLPOINTERS,A1		; Bitplanepointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	; Pointen auf den Sprite

	move.l	#MEINSPRITE,d0	; Adresse des Sprite in d0
	lea	SpritePointers,a1	; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

;-------------------------------	
; Copper-Sprites bentigen: 
; 13*wait
; 13*23 SPR0POS
; 13*23 COP-NOP
; +2 fr die Reihen
; = 4*(13+299+299+2) = ca. 2500.l

initcopper:
	move.l	#$1a29fffe,d0			; wait
	move.l  #$01401a30,d1			; SPR0POS Start
	add.l   d6,d1
	move.l  #$01fe0000,d2			; COP-NOP

	lea coppersprite,a0
	move.l #MEINSPRITE+4,d7
	
	moveq #4-1,d5					; 2 Reihen
reihen:
	moveq #13-1,d4					; 13 Zeilen	
zeilen:
	moveq #23-1,d3					; 22 Anzahl Sprites horizontal nebeneinander
	move.l	d0,(a0)+				; wait
hor:	
	move.l	d1,(a0)+				; SPR0POS V=$1a, H=$40+8*n
	move.l  d2,(a0)+				; Copper-NOP
	add.b	#8,d1					; nchste horizontale Position	
	dbf d3,hor
	add.l #$01000000,d0				; nchste Zeile
	move.b  #$30,d1					; SPR0POS zurcksetzen
	dbf d4,zeilen

	; Spritepointer zurcksetzen in Copperliste
	; ab 2 Reihen
	move.w  #$0122,(a0)+			; SPR0PTL		
	move.w	d7,(a0)+				; low-Anteil Adresse eintragen
	;move.l	#$01424e00,(a0)+		; SPR0CTL V=$1a+Reihen*13, H=0	$1a+4*13=$4e
									; (1 - $27), 2 - $34, 3 - $41 , 4 - $4e 
	dbf d5,reihen

	; um Sprite DMA zu beenden						
	move.l #$01440000,(a0)+			; SPR0DATA - aktiviert das Sprite 
	move.l #$01420000,(a0)+			; SPR0CTL - deaktiviert Sprite DMA
	move.l #$fffffffe,(a0)+
;-------------------------------

	move.l	#COPPERLIST,$dff080	; unsere COP
	move.w	d0,$dff088		; START COP
	move.w	#0,$dff1fc		; NO AGA!
	move.w	#$c00,$dff106	; NO AGA!

mouse:
	btst	#6,$bfe001		; Maustaste gedrckt?
	bne.s	mouse

	move.l	OldCop(PC),$dff080	; Pointen auf die alte SystemCopperlist
	move.w	d0,$dff088		; Starten die alte SystemCopperlist

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable
	move.l	gfxbase(PC),a1
	jsr	-$19e(a6)			; Closelibrary
	rts

;	Daten

GfxName:
	dc.b	"graphics.library",0,0


GfxBase:
	dc.l	0

OldCop:
	dc.l	0


	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8e,$1a5c		; DiwStrt
	dc.w	$90,$80d4		; DiwStop
	dc.w	$92,$20			; DdfStart
	dc.w	$94,$d8			; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod

				; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres

BPLPOINTERS:
	dc.w	$e0,0,$e2,0		; erste Bitplane

	dc.w	$180,$000		; color0	; Hintergrund Schwarz
	dc.w	$182,$123		; color1	; Farbe 1 der Bitplane, die
							; in diesem Fall leer ist,
							; und deswegen nicht erscheint

	dc.w	$1A2,$F00		; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0		; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0		; Color19, oder COLOR3 des Sprite0 - GELB

coppersprite:
	blk.l	2500,$0

	dc.w	$FFFF,$FFFE		; Ende der Copperlist


; ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:		; Lnge 13 Zeilen
VSTART:
	dc.b $1a	; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $00	; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $4e	; $1a+13=$27 - Vertikale Endposition des Sprite
	dc.b $00
 dc.w	%0000000000000000,%1000110000110001 ; Binres Format fr ev. nderungen
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (DURCHSICHTIG)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.


	SECTION LEERESPLANE,BSS_C	; Eine auf 0 gesetzte Bitplane, wir
							; mssen es verwenden, denn ohne Bitplane
							; ist es nicht mglich, die Sprites
							; zu aktivieren
BITPLANE:
	ds.b	40*256			; Bitplane auf 0 Lowres

	end



Erklrung:

In diesem Beispiel wurde das horizontale Spritemultiplexing auf mehrere Reihen
erweitert. Man merkt schnell das die Copperliste im Speicher schnell anwchst.

Wir knnen in der Sprite-Struktur das Summenende angeben: $4e und sparen damit
Copper-Zyklen.

Da wir nach dem Anzeigen der letzen Reihe des Sprites den Spritezeiger wieder
zurcksetzen liest die Hardware das nchste Datenpaar wieder als Steuerwrter
ein, welche dann zu ungewollten neuen Datenabrufen fhren knnen.
Eine Mglichkeit wre die Copperliste umzubauen um nicht zum Ende die 
Spritezeiger zu verndern, sondern vor Beginn. Dies wrde jedoch mehr Copper
Zyklen bentigen, da auch nun zustzliche Copper-Waits erforderlich wren.

Eine andere Mglichkeit wre das Sprite-Data-Fetch ausserhalb des sichtbaren
Screens zu rearmen.

	; um Sprite DMA zu beenden						
	move.l #$01440000,(a0)+			; SPR0DATA - aktiviert das Sprite 
	move.l #$01420000,(a0)+			; SPR0CTL - deaktiviert Sprite DMA 