
; Listing25e.s

; Sprite anzeigen ohne Bitplane DMA	(WinUAE bentigt cycle-exact)
; durch einmaliges Schreiben in BPL1DAT vor dem Anzeigen des Sprites
; Schreiben der Werte in BPL1DAT erfolgt in einer Copperschleife

	SECTION R'nR,CODE


Anfang:
	move.l	4.w,a6				; Execbase
	jsr	-$78(a6)				; Disable
	lea	GfxName(PC),a1			; Libname
	jsr	-$198(a6)				; OpenLibrary
	move.l	d0,GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop		; speichern der alten Cop

;	Pointen auf das "leere" Bild
	MOVE.L	#BITPLANE,d0		; Adresse der Bitplane
	LEA	BPLPOINTERS,A1			; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

;	Pointen auf den Sprite
	MOVE.L	#MEINSPRITE,d0		; Adresse des Sprite in d0
	LEA	SpritePointers,a1		; Pointer in der Copperlist
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)

	move.l	#copperloop,d0		; Adresse Beginn Copperloop
	move	d0,cpptr1+6			; Pointer in der Copperlist
	swap	d0
	move	d0,cpptr1+2

	move.w	#$0100,$dff096		; Bitplane DMA ausschalten

	move.l	#COPPERLIST,$dff080	; unsere COP
	;move.w	d0,$dff088			; START COP - wird automatisch mit VBL gestartet
	move.w	#0,$dff1fc			; NO AGA!
	move.w	#$c00,$dff106
	

mouse:
	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	mouse

	move.w	#$8100,$dff096		; Bitplane DMA wieder einschalten
	move.l	OldCop(PC),$dff080	; Pointen auf die SystemCOP
	move.w	d0,$dff088			; Starten die alte SystemCOP

	move.l	4.w,a6
	jsr	-$7e(a6)				; Enable
	move.l	GfxBase(PC),a1
	jsr	-$19e(a6)				; Closelibrary
	rts					
	
	
;	Daten
GfxName:
	dc.b	"graphics.library",0,0
GfxBase:
	dc.l	0
OldCop:
	dc.l	0
	

	SECTION GRAPHIC,DATA_C

COPPERLIST:
SpritePointers:
	dc.w	$120,0,$122,0,$124,0,$126,0,$128,0 ; SPRITE
	dc.w	$12a,0,$12c,0,$12e,0,$130,0,$132,0
	dc.w	$134,0,$136,0,$138,0,$13a,0,$13c,0
	dc.w	$13e,0

	dc.w	$8E,$2ca1	; DiwStrt
	dc.w	$90,$2cc1	; DiwStop
	dc.w	$92,$d0		; DdfStart
	dc.w	$94,$d8		; DdfStop
;----------------------------------------------------------
	dc.w	$102,0		; BplCon1
	dc.w	$104,$24	; BplCon2
	dc.w	$108,0		; Bpl1Mod
	dc.w	$10a,0		; Bpl2Mod

			    ; 5432109876543210
	dc.w	$100,%0001001000000000  ; Bit 12 an!! 1 Bitplane Lowres
	
BPLPOINTERS:
	dc.w	$e0,0,$e2,0	; erste Bitplane

	dc.w	$180,$000	; Color0	; Hintergrund Schwarz
	dc.w	$182,$080	; Color1	; Farbe 1 der Bitplane

	dc.w	$1A2,$F00	; Color17, oder COLOR1 des Sprite0 - ROT
	dc.w	$1A4,$0F0	; Color18, oder COLOR2 des Sprite0 - GRN
	dc.w	$1A6,$FF0	; Color19, oder COLOR3 des Sprite0 - GELB
		
cpptr1:
	dc.w	$084,0
	dc.w	$086,0

	dc.w	$2c01,$fffe	; wait , wo das Sprite beginnen soll
copperloop:
	dc.w	$0091,$00fe
	dc.w	$0110,$5555	; BPL1DAT
	dc.w	$00e1,$80fe ; auf das Ende der Zeile warten
					
	dc.w	$39e1,$ffff ; skip loop for lines >=$fe 
	dc.w	$8a,0			
							
	dc.w	$ffff,$fffe	; Ende der Copperlist


 ************ Hier ist der Sprite: NATRLICH mu er in CHIP RAM sein! ************

MEINSPRITE:	  ; Lnge 13 Zeilen
VSTART:
	dc.b $2c  ; Vertikale Anfangsposition des Sprite (von $2c bis $f2)
HSTART:
	dc.b $a0  ; Horizontale Anfangsposition des Sprite (von $40 bis $d8)
VSTOP:
	dc.b $39  ; $30+13=$3d - Vertikale Endposition des Sprite
	dc.b $00																						
																						
 dc.w	%0000000000000000,%0000110000110000 ; Binres Format fr ev. nderungen			
 dc.w	%0000000000000000,%0000011001100000
 dc.w	%0000000000000000,%0000001001000000
 dc.w	%0000000110000000,%0011000110001100 ; BINR 00=COLOR 0 (Transparent)
 dc.w	%0000011111100000,%0110011111100110 ; BINR 10=COLOR 1 (ROT)
 dc.w	%0000011111100000,%1100100110010011 ; BINR 01=COLOR 2 (GRN)
 dc.w	%0000110110110000,%1111100110011111 ; BINR 11=COLOR 3 (GELB)
 dc.w	%0000011111100000,%0000011111100000
 dc.w	%0000011111100000,%0001111001111000
 dc.w	%0000001111000000,%0011101111011100
 dc.w	%0000000110000000,%0011000110001100
 dc.w	%0000000000000000,%1111000000001111
 dc.w	%0000000000000000,%1111000000001111
 dc.w	0,0	; 2 word auf NULL definieren das Ende des Sprite.

BITPLANE:
	blk.b 10240,$ff		; fr 320x256	$FF fr Vollbild
	end


In diesem Beispiel wird gezeigt wie es mglich ist ein Sprite anzuzeigen ohne 
das Bitplane DMA aktiviert sein muss. Einfach durch einmaliges Schreibens eines
Wertes in BPLxDAT auf jeder Rasterzeile vor bzw. mit Beginn des Sprites.
