
; Listing26d.s		; ProPack (siehe Listing4b.s)

 SECTION CIPundCOP,CODE		; auch Fast ist  OK

Anfang:
	move.l	4.w,a6			; Execbase in a6
	jsr	-$78(a6) 			; Disable - stoppt das Multitasking
	lea	GfxName(PC),a1		; Adresse des Namen der zu ffnenden Lib in a1
	jsr	-$198(a6)			; OpenLibrary, Routine der EXEC, die Libraris
							; ffnet, und als Resultat in d0 die Basisadr.
							; derselben Bibliothek liefert, ab welcher
							; die Offsets (Distanzen) zu machen sind
	move.l	d0,GfxBase		; speichere diese Adresse in GfxBase
	move.l	d0,a6
	move.l	$26(a6),OldCop	; hier speichern wir die Adresse der Copperlist
							; des Betriebssystemes (immer auf $26 nach GfxBase)

*****************************************************************************
*
* IN:	a0, packed data
*		a1, destination
* OUT:	d0.l = length of unpacked file in bytes OR error code
*		 0 = not a packed file
*		-1 = packed data CRC error
*		-2 = unpacked data CRC error
* TRASHED:	d0-d1/a0-a1
*****************************************************************************
	
	lea	PIC2,a0
	lea	PIC3,a1

LIB_RNC_Depack:
	moveq	#0,d0			; No key
	bsr.w	Unpack


;******************************************************************************
;HIER LASSEN WIR UNSERE BPLPOINTERS IN DER COPPELIST UNSERE BITPLANES ANPOINTEN
;******************************************************************************

	;MOVE.L	#PIC,d0			; Original (siehe Listing4b.s)
	MOVE.L	#PIC3,d0			; in d0 kommt die Adresse von unserer PIC
							; bzw. wo ihre erste Bitplane beginnt

	LEA	BPLPOINTERS,A1		; in a1 kommt die Adresse der Bitplane-
							; Pointer der Copperlist
	MOVEQ	#2,D1			; Anzahl der Bitplanes -1 (hier sind es 3)
							; fr den DBRA - Zyklus
POINTBP:
	move.w	d0,6(a1)		; kopiert das niederwertige Word der Plane-
							; Adresse ins richtige Word der Copperlist
	swap	d0				; vertauscht die 2 Word in d0 (Z.B.: 1234 > 3412)
							; dadurch kommt das hochwertige Word an die
							; Stelle des niederwertigen, wodurch das
							; kopieren mit dem Move.w ermglicht wird!!
	move.w	d0,2(a1)		; kopiert das hochwertige Word der Adresse des 
							; Plane in das richtige Word in der Copperlist
	swap	d0				; vertauscht erneut die 2 Word von d0 (3412 > 1234)
							; damit wird die orginale Adresse wieder hergestellt
	ADD.L	#40*256,d0		; Zhlen 10240 zu D0 dazu, somit zeigen wir
							; auf das zweite Bitplane (befindet sich direkt
							; nach dem ersten), wir zhlen praktisch die Lnge
							; eines Plane dazu
							; In den nchsten Durchgngen werden wir dann auf die
							; dritte, vierte... Bitplane zeigen

	addq.w	#8,a1			; a1 enthlt nun die Adresse der nchsten
							; bplpointers in der	Copperlist, die es
							; einzutragen gilt
	dbra	d1,POINTBP		; Wiederhole D1 mal POINTBP (D1=num of bitplanes)


	move.l	#COPPERLIST,$dff080	; COP1LC - "Zeiger" auf unsere COP
							; (deren Adresse)
	move.w	d0,$dff088		; COPJMP1 - Starten unsere COP

	move.w	#0,$dff1fc		; FMODE - Deaktiviert das AGA
	move.w	#$c00,$dff106	; BPLCON3 - Deaktiviert das AGA

mouse:	
	btst	#6,$bfe001		; linke Maustaste gedrckt?
	bne.s	mouse			; wenn nicht, zurck zu mouse:

	move.l	OldCop(PC),$dff080 	; COP1LC - "Zeiger" auf die Orginal-COP
	move.w	d0,$dff088		; COPJMP1 - und starten sie

	move.l	4.w,a6
	jsr	-$7e(a6)			; Enable - stellt Multitasking wieder her
	move.l	GfxBase(PC),a1	; Basis der Library, die es zu schlieen gilt
							; (Libraries werden geffnet UND geschlossen!)
	jsr	-$19e(a6)			; Closelibrary - schliet die Graphics lib
	rts

GfxName:
	dc.b	"graphics.library",0,0	

GfxBase:	    ; Hier hinein kommt die Basisadresse der graphics.library,
	dc.l	0   ; ab hier werden die Offsets gemacht



OldCop:			; Hier hinein kommt die Adresse der Orginal-Copperlist
	dc.l	0	; des Betriebssystemes

	
	INCLUDE "/Packer/PP/RNC_1.S"	

	SECTION GRAPHIC,DATA_C

COPPERLIST:

	; Die Sprites lassen wir auf NULL zeigen, also pointen, um sie zu 
	; eliminieren ansonsten geistern sie umher uns stren uns nur!!!

	;dc.w	$120,$0000,$122,$0000,$124,$0000,$126,$0000,$128,$0000
	;dc.w	$12a,$0000,$12c,$0000,$12e,$0000,$130,$0000,$132,$0000
	;dc.w	$134,$0000,$136,$0000,$138,$0000,$13a,$0000,$13c,$0000
	;dc.w	$13e,$0000

	dc.w	$8e,$2c81		; DiwStrt	Register mit Standartwerten
	dc.w	$90,$2cc1		; DiwStop
	dc.w	$92,$0038		; DdfStart
	dc.w	$94,$00d0		; DdfStop
	dc.w	$102,0			; BplCon1
	dc.w	$104,0			; BplCon2
	dc.w	$108,0			; Bpl1Mod
	dc.w	$10a,0			; Bpl2Mod
		
; das BPLCON0 ($dff100) fr einen Bildschirm mit 3 Bitplanes: (8 Farben)

		    ; 5432109876543210
	dc.w	$100,%0011001000000000	; bits 13 und 12 an!! (3 = %011)

;	Wir lassen die Bitplanes direkt anpointen, indem wir die Register
;	$dff0e0 und folgende hier in der Copperlist einfgen. Die
;	Adressen der Bitplanes werden dann von der Routine POINTBP
;	automatisch eingetragen

BPLPOINTERS:
	dc.w	$e0,$0000,$e2,$0000	; erste	Bitplane - BPL0PT
	dc.w	$e4,$0000,$e6,$0000	; zweite Bitplane - BPL1PT
	dc.w	$e8,$0000,$ea,$0000	; dritte Bitplane - BPL2PT

;	Die 8 Farben des Bildes werden hier definiert:

	dc.w	$0180,$000		; color0
	dc.w	$0182,$475		; color1
	dc.w	$0184,$fff		; color2
	dc.w	$0186,$ccc		; color3
	dc.w	$0188,$999		; color4
	dc.w	$018a,$232		; color5
	dc.w	$018c,$777		; color6
	dc.w	$018e,$444		; color7
	;	Fgt hier eventuelle WAIT-Effekte ein:

	dc.w	$a907,$FFFE		; warte auf Zeile $a9
	dc.w	$180,$001		; sehr dunkles Blau
	dc.w	$aa07,$FFFE		; Zeile $aa
	dc.w	$180,$002		; ein bichen helleres Blau
	dc.w	$ab07,$FFFE		; Zeile $ab
	dc.w	$180,$003		; ein bichen helleres Blau
	dc.w	$ac07,$FFFE		; nchste Zeile
	dc.w	$180,$004		; ein bichen helleres Blau
	dc.w	$ad07,$FFFE		; nchste Zeile
	dc.w	$180,$005		; ein bichen helleres Blau
	dc.w	$ae07,$FFFE		; nchste Zeile
	dc.w	$180,$006		; Blau auf 6
	dc.w	$b007,$FFFE		; berspringe 2 Zeilen
	dc.w	$180,$007		; Blau auf 7
	dc.w	$b207,$FFFE		; berspringe 2 Zeilen
	dc.w	$180,$008		; Blau auf 8
	dc.w	$b507,$FFFE		; berspringe 3 Zeilen
	dc.w	$180,$009		; Blau auf 9
	dc.w	$b807,$FFFE		; berspringe 3 Zeilen
	dc.w	$180,$00a		; Blau auf 10
	dc.w	$bb07,$FFFE		; berspringe 3 Zeilen
	dc.w	$180,$00b		; Blau auf 11
	dc.w	$be07,$FFFE		; berspringe 3 Zeilen
	dc.w	$180,$00c		; Blau auf 12
	dc.w	$c207,$FFFE		; berspringe 4 Zeilen
	dc.w	$180,$00d		; Blau auf 13
	dc.w	$c707,$FFFE		; berspringe 7 Zeilen
	dc.w	$180,$00e		; Blau auf 14
	dc.w	$ce07,$FFFE		; berspringe 6 Zeilen
	dc.w	$180,$00f		; Blau auf 15
	dc.w	$d807,$FFFE		; berspringe 10 Zeilen
	dc.w	$180,$11F		; helle auf...
	dc.w	$e807,$FFFE		; berspringe 16 Zeilen
	dc.w	$180,$22F		; helle auf...
	dc.w	$ffdf,$FFFE		; ENDE DER NTSC-ZONE (Zeile $FF)
	dc.w	$180,$33F		; helle auf...
	dc.w	$2007,$FFFE		; Zeile $20+$FF = Zeile $1ff (287)
	dc.w	$180,$44F		; helle auf...
;------------------------------------

	dc.w	$FFFF,$FFFE		; Ende der Copperlist


;	Erinnert euch, die Directory auszuwhlen, in der das Bild zu
;	finden ist, in diesem Fall: "V df0:LISTINGS2"


PIC:
	;incbin  "/Sources/Amiga_320_256_3.raw"
							; hier laden wir das Bild im RAW
							; Format, das zuvor mit dem
							; KEFCON konvertiert wurde, es
							; besteht aus drei Bitplanes
							; nacheinander	

PIC2:
	incbin  "/Packer/Amiga_320_256_3.RNC"


	SECTION Bitplane,BSS_C

PIC3:
	ds.b 3*40*256			; freier Platz Bitplane	

	end


Erklrung:

Wo bekomme ich ProPack?
===============================================================================
Quelle: RNC_ProPack.lha von Aminet - util_pack_RNC_ProPack.lha
Inhalt:
PPAMI.EXE		; Amiga
PPIBM.EXE		; MS-DOS 16-Bit	(funktioniert mit Dosbox-Emulator)	
PROPACK.DOC		

Sourcecode:
RNC_1.S
RNC_1C.S
RNC_2.S
RNC_2C.S

Eine 32Bit bzw. 64Bit-Variante findet man hier:
https://github.com/lab313ru/rnc_propack_source
Diese kann man z.B. mit VisualStudio in eine rnc_propack_x64.exe 
generieren. Diese Variante hat die gleichen Ergebnisse wie PPAMI.EXE
geliefert.

Ansonsten findet man auch noch hier eine Propack Version:
https://codetapper.com/amiga/random-rants/rob-northen-propack/
Diese Variante hat aber im Test nicht 100% das gleiche Ergebnis geliefert
wie die PPAMI.EXE und PPIBM.EXE

Amiga Shelll
===============================================================================
1.DH1:>PPAMI.EXE
PRO-PACK 2.88 Software Developers File Compression Utility 3 App 92
Copypright (c) 1991,92 Rob Northen Computing UK. All Rights Reserved
PO Box 17 Bordon Hants GU35 8DY U.K. Tel:0428-713635 Fax:0428-713999

Usage: PP <command> <file type> [-<options>] [.<ext>] <file(s)...>

<Commands> p: Pack u: Unpack v: Verify

<File Types> (file types <psam> are made to unpack when run)

d: Data p: IBM PC s: Atari ST a: CBM Amiga m: MC68000 l: Atari Lynx

<Options> (p=pack command, u=unpack command, v=verify command)
-k: (puv) lock/unluck with Key	 -o: (p) Overwrite input <file>
-k 0x1234 (hex)				     -p: (p) change Pack block size
-l: (p) Lock <file> (stops unpacking) -p 10240 (10240 bytes)
-m: (p) packing Method (default=1)  -v: (p) Validate data when unpacking
-m 1 emphasis on packed size		-x: (p) MC68000 eXec address offset
-m 2 emphasis on unpacking speed	-x 0x100 jumps to start + 0x100

[.<ext>] output file extension
1.DH1:>rename PPAMI.EXE PPAMI

D.h typische Aufrufe wren.
1.DH1:>PPAMI p a -m 1 text.exe
1.DH1:>PPAMI p d Tabelle1

1.DH1:>PPAMI u a - m 1 test.exe.rnc
1.DH1:>PPAMI U D Tabelle1.rnc

Fileformat
===============================================================================
; RNC1.new fileformat:
; 0 BYTE "RNC",$01
; 4 LONG unpacked size
; 8 LONG packed stream size
; c WORD unpacked crc
; e WORD packed crc
; 10 UBYTE required offset if decrunching over itself
; 11 BYTE
; 12 STRUCT packed stream
; decrunching source++ destination++

